/*
 * Empire, the Wargame of the Century (tm)
 * Copyright (C) 1978-2004 by Walter Bright
 * All Rights Reserved
 *
 * You may use this source for personal use only. To use it commercially
 * or to distribute source or binaries of Empire, please contact
 * www.digitalmars.com.
 *
 * Written by Walter Bright.
 * This source is written in the D Programming Language.
 * See www.digitalmars.com/d/ for the D specification and compiler.
 *
 * Use entirely at your own risk. There is no warranty, expressed or implied.
 */

private {
  import minwin.all;
  import minwin.logging;
  import std.c.stdio;
  import std.c.stdlib;
  import std.file;
  import std.string;
}
void help() {
  Window helpWindow;
  // or can add a destroy event listener and store handle globally
  foreach(AbstractWindow w; Window.WindowList) {
    if (w.name == "helpWindow") {
      helpWindow = cast(Window)w;
      break;
    }
  }
  if (helpWindow is null) {
    helpWindow = new Window("Empire Help","helpWindow");
    BorderLayout mgr = new BorderLayout;
    helpWindow.layoutMgr = mgr;
    char[] buffer;
    buffer = cast(char[])std.file.read("help.txt");
    char[][] lines = splitlines(buffer);
    version(Windows) {
      buffer = join(lines,\r\n);
    } else {
      buffer = join(lines,\n);
    } // mac?

    // add scrollbar and make not-editable
    MultiLineText t = new MultiLineText(helpWindow,buffer);
    //    version(LOG)log.writefln("%s",buffer);
    t.userPreferredSize(400,400);
    mgr.location[Loc.Center] = t;
    helpWindow.pack();
  }
  helpWindow.visible = true;
}
